%Klasyczny algorytm genetyczny
%Analiza czstoci znalezienia optimum wielomodalnej funkcji celu

clear;
nr_gr = 1.2;  %tu wprowad nr swojej podgrupy
rok_kal=2007; %tu wprowad rok kalendarzowy
rand('state',sum(rok_kal*nr_gr*100)); qq = rand

l_maksimow=50; 
s = 1; %odwrotno szerokoci maksimum
w = 2; %wysoko maksimum
p = qq; %przesunicie punktu maksimum wzgldem osi x
poziom = 2; %przesunicie funkcji wzgldem osi y (>1)

x_p=-pi*l_maksimow;  %ograniczenie dolne zmiennej
x_k=pi*l_maksimow;  %ograniczenie grne zmiennej
blad=0.05; %dokadno lokalizacji optimum
q=2;  %dokadno (liczba cyfr po przecinku)
N=20;  %liczno populacji
p_c=0.9;  %prawdopodobiestwo krzyowania
p_m=0.05;  %prawdopodobiestwo mutacji
L_gen=100;  %maksymalna liczba generacji
L_u = 30; %liczba uruchomie AG do oszacowania c_opt

%okrelenie dugoci chromosomu
l_odc=(x_k-x_p)*10^q;
m=ceil(log2(l_odc+1));	%minimalna liczba bitw do zakodowania zmiennej z dokadnoci q

%wyznaczenie maksimum funkcji celu
x=x_p:blad/5:x_k;
y=F_celu2(x,s,w,p,poziom,qq);
x_max=x(find(y==max(y)));
%****************************

c_opt=0;
l_opt = [];

%L_u-krotnie uruchamiamy AG
for j=1:L_u

    %losowanie populacji pocztkowej
    ch=round(rand(N,m));
    
    for i=1:L_gen
        
        %dekodowanie populacji 
        x=dekoduj(ch,N,m,x_p,x_k);
            
        %funkcja przystosowania pop. poczatkowej
        F=F_celu2(x,s,w,p,poziom,qq);
        [F_max(i),index]=max(F);		%maksymalna warto f. przystosowania
        F_sr(i)=mean(F);		%rednia warto f. przystosowania
        x_opt=x(index(1));
                 
        %zapamietanie najlepszego osobnika
        if abs(x_opt-x_max)<blad
            c_opt=c_opt+1;
            l_opt=[l_opt i];
            break;
        end
        
        %prawdopodobiestwa selekcji
        p_s=F/(F_sr(i)*N);
        
        %regua ruletki
        nr_ch=ruletka(p_s,N);
        
        %pula rodzicielska
        ch=ch(nr_ch,:);
        
        %krzyowanie
        ch=krzyzuj(ch,N,m,p_c);
        
        %mutacja
        ch=mutuj(ch,N,m,p_m);
        
    end;
end;
%rezultaty
c_opt=c_opt/L_u;
l_opt=mean(l_opt)/L_gen;
fprintf('Czsto znalezienia optimum: %5.2f\n',c_opt);
fprintf('redni wzgldny nr generacji, w ktrej AG znalaz rozwizanie optymalne: %5.2f\n',l_opt);


